/* dcl.c
	parse declaration
	P.Chongstitvatana
					25 Aug 97
					28 Aug 98

	3 Apr 2001   start project RZ
*/

#include "compile.h"

#define		PRIVATE		static

int DS = 1;	/* index to data segment */
int mainRef;    /* index to symtab refer to main */

extern FILE *FI,*FO;
extern int pass;

PRIVATE int formalParam(char *namelist)
{
  int pv = 0;
  namelist[0] = 0;
  lex();
  while( tok == tkIDENTIFIER ) {
    strcat(namelist,tokstring);
	strcat(namelist," ");
    pv++;
    lex();
    if( tok == tkRPAREN ) break;
    expect(tkCOMMA,"expect ,");
    lex();
  }
  expect(tkRPAREN,"expect )");
  return pv;
}

PRIVATE void skipcomment() {
  getC();
  if( CH == '/') {
    while( CH != NL_CHAR && CH != EOF_CHAR )
      getC();
    if( CH == NL_CHAR ) {
      doline();
      putc(CH,FO);
    }
  }else {
    unget();
    putc('/',FO);
  }
}

PRIVATE void copyBody()
{
  int cnt = 1;
  lex();
  expect(tkLBRACE,"expect {");
  fprintf(FO,"\n%d {",line);
  if( CH == EOF_CHAR ) seterror("unexpect EOF");
  while( cnt > 0 && CH != EOF_CHAR ) {
    switch( CH ) {
    case '{'     : cnt++; putc(CH,FO);break;
    case '}'     : cnt--; putc(CH,FO); break;
    case NL_CHAR : doline(); putc(CH,FO); break;
    case '/'     : skipcomment(); break;
    default      : putc(CH,FO);
    }
    getC();
  }
  putc('\n',FO);
}

PRIVATE void functionDcl(char *name)
{
  int a,pv,found;
  char namelist[200];	// formal parameters name list
  pv = formalParam(namelist);
  a = installGlobal(name,tyFUNCTION,0,pv,&found);
  fprintf(FO,"%d %s\n",a,namelist);
  if(found) seterror("redefine function");
  copyBody();
}

PRIVATE int doindex()
{
  int a;
  lex();
  expect(tkNUMBER,"size of array must be number");
  a = atoi(tokstring);
  lex();
  expect(tkRBRACKET,"expect ]");
  return a;
}

PRIVATE void idenDcl()
{
  int size,type,found;
  char name[NAMELEN];
  strcpy(name,tokstring);
  lex();
  if( tok == tkLPAREN ) functionDcl(name);
  else
  while(tok == tkSEMICOLON || tok == tkCOMMA || tok == tkLBRACKET) {
    size = 1;
    type = tySCALAR;
    if( tok == tkLBRACKET ) {
      size = doindex();
      type = tyVECTOR;
      lex();
    }
	installGlobal(name,type,DS,size,&found);
	if(found) seterror("redefine global name");
    DS += size;
    if( tok == tkSEMICOLON ) break;
    expect(tkCOMMA,"expect ,");
    lex();
    expect(tkIDENTIFIER,"expect identifier");
    strcpy(name,tokstring);
    lex();
  }
}

PRIVATE void mainDcl()
{
  int a, found;
  a = installGlobal("main",tyFUNCTION,0,0,&found);
  if( found ) seterror("redefine main");
  mainRef = a;
  fprintf(FO,"%d ",a);
  lex();
  expect(tkLPAREN,"main, expect (");
  lex();
  expect(tkRPAREN,"expect )");
  copyBody();
}

void pass1()
{
  pass = 1;
  lex();
  while( tok != tkEOF ) {
    switch( tok ) {
    case tkIDENTIFIER :	idenDcl(); break;
    case tkMAIN : 	    mainDcl(); break;
    default :           seterror("unknow token");
    }
    lex();
  }
}
