
/* mon.c  monitor for command line interpreter */

#include "s2.h"

#define MXBUF  80
#define MXBP  20
#define sep  "\t\n "

extern int runflag;
extern int R[32], Ir, Mdr, Mar, Pc, T, Z, S, M[20000];

void run();
void show();

int bplist[MXBP], nbp;
char ibuf[MXBUF], *cp = NULL;
FILE *fi;

char *tok(){	/* get one token from input */
	if( cp != NULL ) cp = strtok(NULL,sep);
	while ( cp == NULL ){
		printf(">");
		cp = fgets(ibuf,MXBUF,fi);
		if( cp != NULL ) cp = strtok(ibuf, sep);
	}
	cp = strupr(cp);   /* convert to uppercase */
// printf("%s ",cp);
	return cp;
}

void testtok(){
	char *w;
	fi = stdin;
	cp = NULL;
	while(1){
		w = tok();
		printf("%s ",w);
		if( eqs(w,"QUIT")) break;
	}
}

char  *readA(){
	char *w;
	w = tok();
	return w;
}

void setBp(int ads){
	bplist[nbp] = ads;
	nbp++;
	if( nbp >= MXBP ) error("too many breakpoints");
}

void clearBp() { nbp = 0; }

int isbreak(){
	int i;
	for(i=0;i<nbp;i++)
		if( Pc == bplist[i] ) return 1;
	return 0;
}

void trace(){
	while(!isbreak() && runflag) {
		run();
		show();
	}
}

int isReg(char *s){
	int n;
	if( s[0] == 'R') {
		n = atoi(s+1);
		if( n > 0 && n < 32 ) return 1;
	}
	return 0;
}

void wR(int r, int value);

void setArg(char *s, int value){
	if( isReg(s) )
		wR(atoi(s+1),value);
	else if ( eqs(s,"PC") )
		Pc = value;
	else if ( eqs(s,"Z") )
		Z = value;
	else if ( eqs(s,"S") )
		S = value;
	else if ( s[0] == 'M' )
		M[atoi(s+1)] = value;
	else
		printf("set unknow argument\n");
}

void dumpMem(int ads, int n){
	int i,k;
	k = 0;
	printf("%4d : ",ads);
	for(i=ads;i<ads+n;i++){
		printf("%d ",M[i]);
		k++;
		if( k%10 == 0 ) printf("\n%4d : ",i);
	}
}

void moveMem(int ads1, int ads2, int n){
	int i;
	for(i=0;i<n;i++) M[ads2++] = M[ads1++];
}

void help(){
	printf("g go, t single step, b set breakpoint, c clear break point\n");
    printf("s set [rn,mn,pc,z,s], d dump a1 n, m move mem a1 a2 n\n");
	printf("r register, h help\n");
}

void interp(){
	char *w, *arg, *v, *v2;
	int i;
	fi = stdin;
	cp = NULL;
	while(1){
		w = tok();
		switch( w[0] ){
		case 'G': trace(); break;
		case 'T': run(); show(); break;
		case 'B':
			arg = readA();
			setBp(atoi(arg));
			break;
		case 'C': clearBp(); break;
		case 'S':
			arg = readA();
			v = readA();
			setArg(arg,atoi(v));
			break;
		case 'D':
			arg = readA();
			v = readA();
			dumpMem(atoi(arg),atoi(v));
			break;
		case 'M':
			arg = readA();
			v = readA();
			v2 = readA();
		    moveMem(atoi(arg),atoi(v),atoi(v2));
			break;
		case 'R':
			for(i=0;i<32;i++){
			   if(i%8 == 0) printf("\n");
			   printf("r%d:%d ",i,R[i]);
			}
			printf("\n");
			break;
		case 'H': help(); break;
		default: printf("unknow command\n");
		}
	}
}


